CREATE TABLE CADASTROPROJETO
(
    CDPROJETO     	VARCHAR2(3)     NOT NULL,  
    IDPROJETO     	VARCHAR2(5)     NOT NULL,
    DSPROJETO     	VARCHAR2(32)    NOT NULL,
    NRORG           NUMBER    		DEFAULT   SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO   		VARCHAR2(1) 	DEFAULT 'S'   NOT NULL
      CONSTRAINT CKC_IDATIVO_CADASTROPROJETO CHECK (IDATIVO IN ('S', 'N')),          
    DTINCLUSAO      DATE            NULL,
    DTULTATU        DATE            NULL, 
    NRORGINCLUSAO   NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERINCLUSAO  VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERULTATU    VARCHAR2(12)    DEFAULT '1' NULL,
        CONSTRAINT PK_CADASTROPROJETO PRIMARY KEY (CDPROJETO) 
)
/

CREATE TABLE LISTAEMAILTEC
(
    CDPROJETO     	VARCHAR2(3)     NOT NULL,
    CDEMAILTEC     	VARCHAR2(4)     NOT NULL,
    DSEMAILTEC     	VARCHAR2(32)    NOT NULL,
    NRORG           NUMBER    		DEFAULT   SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    IDATIVO   		VARCHAR2(1) 	DEFAULT 'S'   NOT NULL
      CONSTRAINT CKC_IDATIVO_LISTAEMAILTEC CHECK (IDATIVO IN ('S', 'N')),          
    DTINCLUSAO      DATE            NULL,
    DTULTATU        DATE            NULL,
    NRORGINCLUSAO   NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERINCLUSAO  VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    CDOPERULTATU    VARCHAR2(12)    DEFAULT '1' NULL,
        CONSTRAINT PK_LISTAEMAILTEC PRIMARY KEY (CDPROJETO,DSEMAILTEC)
)
/

CREATE INDEX VND00767_FK ON LISTAEMAILTEC (CDPROJETO ASC)
/

ALTER TABLE LISTAEMAILTEC
   ADD CONSTRAINT FKVND00767CADASTROPROJETO FOREIGN KEY (CDPROJETO)
      REFERENCES CADASTROPROJETO (CDPROJETO)
/

INSERT INTO CADASTROPROJETO(CDPROJETO, IDPROJETO, DSPROJETO) VALUES('001','1', 'No Cash') 
/

INSERT INTO CADASTROPROJETO(CDPROJETO, IDPROJETO, DSPROJETO) VALUES ('002','2', 'Uber Eats')
/

INSERT INTO CADASTROPROJETO(CDPROJETO, IDPROJETO, DSPROJETO) VALUES ('003','3', 'IFood')
/

INSERT INTO CADASTROPROJETO(CDPROJETO, IDPROJETO, DSPROJETO) VALUES ('004','4', 'Rappi')
/

INSERT INTO CADASTROPROJETO(CDPROJETO, IDPROJETO, DSPROJETO) VALUES ('005','5', 'Onion')
/

INSERT INTO CADASTROPROJETO(CDPROJETO, IDPROJETO, DSPROJETO) VALUES ('006','6', 'My Sales')