/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_OPERLESTOQ                                               */
/* Tabela : OPERLESTOQ                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_OPERLESTOQ
BEFORE INSERT OR UPDATE OR DELETE
ON OPERLESTOQ FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUOPLE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDOPERADOR,0)   <> NVL(:NEW.CDOPERADOR,0)) OR
         (NVL(:OLD.CDFILIAL,0)     <> NVL(:NEW.CDFILIAL,0)) OR
         (NVL(:OLD.CDLOCALESTOQ,0) <> NVL(:NEW.CDLOCALESTOQ,0)) OR
         (NVL(:OLD.CDALMOXARIFE,0) <> NVL(:NEW.CDALMOXARIFE,0)) THEN
         :NEW.DTULTATUOPLE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('OPERLESTOQ',:OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDOPERADOR='||:OLD.CDOPERADOR||';CDALMOXARIFE='||:OLD.CDALMOXARIFE||';CDLOCALESTOQ='||:OLD.CDLOCALESTOQ||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE OPERLESTOQ MODIFY DTULTATUOPLE DEFAULT SYSDATE
/


