/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PAIS                                                     */
/* Tabela : PAIS                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PAIS'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PAIS
GO

CREATE TRIGGER DTULTATU_PAIS
ON PAIS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PAIS', null, 'CDPAIS=' + CDPAIS + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PAIS
      SET DTULTATUPAIS = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PAIS.CDPAIS,0)      = ISNULL(INSERTED.CDPAIS,0)) AND
            (ISNULL(PAIS.NMPAIS,0)      = ISNULL(INSERTED.NMPAIS,0)) AND
            (ISNULL(PAIS.CDPAISBACEN,0) = ISNULL(INSERTED.CDPAISBACEN, 0));
   END;
END;
GO

